using Model;
using Model.Serialization;
using Model.Stub;
using Newtonsoft.Json.Linq;
using NuGet.Frameworks;
using System;

namespace TestUnitaires
{

    public class TU_StubManager
    {
        [Theory]
        [InlineData("Rference")]
        public void TU_Methods(string? test)
        {

            Playlist p = new Playlist(test, "PlaceHolder", "place.holder");
            Album album = new Album(test, "place.holder", new Artist("test"), "PlaceHolder", "PlaceHolder");
            CustomTitle t = new CustomTitle(test, "test. mp3", "Banger", "path");
            Artist artist = new Artist(test);
            StubManager stub = new StubManager();
            InfoTitle info = new InfoTitle(test, "urstub.test", "infos", "desc", Genre.POP, 345);
            /*Assert.NotEmpty(stub.Albums);
            Assert.NotEmpty(stub.Artists);
            Assert.NotEmpty(stub.InfoTitles);
            Assert.NotEmpty(stub.Playlists);
            Assert.NotEmpty(stub.CustomTitles);*/
            stub.AddCustomTitle(t);
            stub.AddPlaylist(p);
            stub.AddAlbum(album);
            stub.AddArtist(artist);
            stub.AddInfoTitle(info);
            Assert.Contains(t, stub.StubCustomTitle.CustomTitles);
            Assert.Contains(album, stub.StubAlbum.Albums);
            Assert.Contains(p, stub.StubPlaylist.Playlists);
            Assert.Contains(info, stub.StubInfoTitle.InfoTitles);
            Assert.Contains(artist, stub.StubArtist.Artists);
            stub.RemovePlaylist(p);
            stub.RemoveAlbum(album);
            stub.RemoveCustomTitle(t);
            stub.RemoveInfoTitle(info);
            Assert.DoesNotContain(t, stub.StubCustomTitle.CustomTitles);
            Assert.DoesNotContain(p, stub.StubPlaylist.Playlists);
            Assert.DoesNotContain(album, stub.StubAlbum.Albums);
            Assert.DoesNotContain(info, stub.StubInfoTitle.InfoTitles);
            stub.AddCustomTitle(t);
            stub.AddPlaylist(p);
            stub.AddAlbum(album);
            stub.AddArtist(artist);
            stub.AddInfoTitle(info);
            Assert.Equal(stub.GetAlbums(), stub.StubAlbum.Albums);
            Assert.Equal(stub.GetInfoTitles(), stub.StubInfoTitle.InfoTitles);
            Assert.Equal(stub.GetCustomTitles(), stub.StubCustomTitle.CustomTitles);
            Assert.Equal(stub.GetPlaylists(), stub.StubPlaylist.Playlists);
            Assert.Equal(stub.GetArtists(), stub.StubArtist.Artists);
            Assert.Equal(stub.GetAlbumByName(test), album);
            Assert.Equal(stub.GetPlaylistByName(test), p);
            Assert.Equal(stub.GetInfoTitleByName(test), info);
            Assert.Equal(stub.GetArtistByName(test), artist);
            Assert.True(stub.ExistsAlbum(album));
            Assert.True(stub.ExistsArtist(artist));
            Assert.True(stub.ExistsPlaylist(p));
            Assert.True(stub.ExistsCustomTitle(t));
            Assert.True(stub.ExistsInfoTitle(info));
            Assert.True(stub.ExistsAlbumByName(test));
            Assert.True(stub.ExistsArtistByName(test));
            Assert.True(stub.ExistsPlaylistByName(test));
            Assert.True(stub.ExistsInfoTitleByName(test));
            Assert.True(stub.ExistsCustomTitleByName(test));
            /*stub.RemovePlaylist(p);
            stub.RemoveAlbum(album);
            stub.RemoveCustomTitle(t);
            stub.RemoveInfoTitle(info);
            stub.RemoveArtist(artist);
            Assert.False(stub.ExistsAlbum(album));
            Assert.False(stub.ExistsArtist(artist));
            Assert.False(stub.ExistsPlaylist(p));
            Assert.False(stub.ExistsCustomTitle(t));
            Assert.False(stub.ExistsInfoTitle(info));
            Assert.False(stub.ExistsAlbumByName(test));
            Assert.False(stub.ExistsArtistByName(test));
            Assert.False(stub.ExistsPlaylistByName(test));
            Assert.False(stub.ExistsInfoTitleByName(test));
            Assert.False(stub.ExistsCustomTitleByName(test));*/


        }
    }
    
}